{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: Main.pas, released 11 Mar 2001.

The Initial Developer of the Original Code is: Jrgen Gntherodt
(jguentherodt@users.sourceforge.net).

Portions created by Jrgen Gntherodt are Copyright (C) 2001 Jrgen Gntherodt.
All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: MAIN.PAS,v 1.3 2001/03/17 04:34:59 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE
home page, located at http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit Main;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, SynEdit, Math, message_interface, clProcess,
  RequestProcessor, PerlDebugger2, ChildWin, registry, iniFiles,
  comObj, activeX, shlObj, shellAPI, breakpoints, elTree;

type
  TExecutionState = (ecsNone, ecsPendingCommand, ecsCompile, ecsDebug, ecsRun);
  
  TMainForm = class(TForm, IMessageReceiver, IDropTarget)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    acFileNew: TAction;
    acFileSave: TAction;
    acFileExit: TAction;
    acFileOpen: TAction;
    acFileSaveAs: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    acFileClose: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    splitLeft: TSplitter;
    pcLeft: TPageControl;
    pcBottom: TPageControl;
    splitBottom: TSplitter;
    pcTop: TPageControl;
    splitTop: TSplitter;
    pcRight: TPageControl;
    splitRight: TSplitter;
    pnlTopDummy: TPanel;
    Run1: TMenuItem;
    acRun: TAction;
    acStepOver: TAction;
    acTraceInto: TAction;
    acProgramReset: TAction;
    acCompile: TAction;
    Compile1: TMenuItem;
    Run2: TMenuItem;
    N3: TMenuItem;
    StepOver1: TMenuItem;
    TraceInto1: TMenuItem;
    N4: TMenuItem;
    ProgramReset1: TMenuItem;
    SaveDialog: TSaveDialog;
    acPreferences: TAction;
    N5: TMenuItem;
    Preferences1: TMenuItem;
    N6: TMenuItem;
    Debugwindows1: TMenuItem;
    miVariables: TMenuItem;
    miBreakpoints: TMenuItem;
    miModules: TMenuItem;
    miConsoleAndCommunication: TMenuItem;
    miErrorOutput: TMenuItem;
    miCallstack: TMenuItem;
    Outputwindows1: TMenuItem;
    Project1: TMenuItem;
    miSetActiveProject: TMenuItem;
    N7: TMenuItem;
    N2: TMenuItem;
    memoDebugScriptTemplate: TMemo;
    pnlTabs: TPanel;
    pnlTabsLeft: TPanel;
    pnlTabsClient: TPanel;
    pnlTabsRight: TPanel;
    tcFiles: TTabControl;
    Label2: TLabel;
    cbxDesktop: TComboBox;
    acFind: TAction;
    acFindInFiles: TAction;
    acReplace: TAction;
    acSearchAgain: TAction;
    acIncrementalSearch: TAction;
    acGoToLineNumber: TAction;
    Search1: TMenuItem;
    Find1: TMenuItem;
    acFindInFiles1: TMenuItem;
    Replace1: TMenuItem;
    SearchAgain1: TMenuItem;
    IncrementalSearch1: TMenuItem;
    N8: TMenuItem;
    GotoLineNumbers1: TMenuItem;
    FindDialog: TFindDialog;
    ReplaceDialog: TReplaceDialog;
    acFileOpen2: TAction;
    acAbout: TAction;
    procedure acFileNewExecute(Sender: TObject);
    procedure acFileOpenExecute(Sender: TObject);
    procedure acFileExitExecute(Sender: TObject);
    procedure pcLeftDockDrop(Sender: TObject;
      Source: TDragDockObject; X, Y: Integer);
    procedure pcLeftUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure pcBottomDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure pcBottomUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure pcTopDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure pcTopUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure pcRightDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure pcRightUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acStepOverExecute(Sender: TObject);
    procedure acTraceIntoExecute(Sender: TObject);
    procedure acRunExecute(Sender: TObject);
    procedure acProgramResetExecute(Sender: TObject);
    procedure acFileSaveExecute(Sender: TObject);
    procedure cbxDesktopKeyPress(Sender: TObject; var Key: Char);
    procedure cbxDesktopClick(Sender: TObject);
    procedure acPreferencesExecute(Sender: TObject);
    procedure Debugwindows1Click(Sender: TObject);
    procedure miBreakpointsClick(Sender: TObject);
    procedure miCallstackClick(Sender: TObject);
    procedure miVariablesClick(Sender: TObject);
    procedure miModulesClick(Sender: TObject);
    procedure miConsoleAndCommunicationClick(Sender: TObject);
    procedure miErrorOutputClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acCompileExecute(Sender: TObject);
    procedure acFileSaveAsExecute(Sender: TObject);
    procedure acFileCloseExecute(Sender: TObject);
    procedure pcLeftResize(Sender: TObject);
    procedure tcFilesChange(Sender: TObject);
    procedure pcRightResize(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure acSearchAgainExecute(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure acReplaceExecute(Sender: TObject);
    procedure ReplaceDialogReplace(Sender: TObject);
    procedure acGoToLineNumberExecute(Sender: TObject);
    procedure acFileOpen2Execute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure Outputwindows1Click(Sender: TObject);
  private
    { Private declarations }
    m_sActiveProjectFile: String;
    m_ws: TWindowState;
    m_bInitializing: Boolean;
    m_bIgnoreLineReport: Boolean;
    function CreateMDIChild(const Name: string; bChangeProject: Boolean): TMDIChild;
    procedure InitDockingWindows;
    function HandleDebugMessage(nMsgID: Integer; sData: String): Integer;
    function WinControlToString(win: TWinControl): String;
    procedure StringToWinControl(win: TWinControl; s: String; var bVisible: Boolean);
    function PageControlToString(pc: TPageControl): String;
    procedure StringToPageControl(pc: TPageControl; s: String);
    procedure UpdateRunActions;
    function ChildFromName(sName: String): TMDIChild;
    function GetBreakpointCount: Integer;
    function GetFindOptions: TSynSearchOptions;
    function GetSearchAndReplaceOptions: TSynSearchOptions;
    procedure HandleGoto(Sender: TObject; var sGoto: String);
  protected
    // IMessageReceiver
    function IMessageReceiver.HandleMessage = HandleDebugMessage;
    function ReceiveFromStdOut(sData: String): Integer;
    function ReceiveFromStdErr(sData: String): Integer;
    function HandleTerminate: Integer;
    procedure HandleCLEvent(Sender: TObject; sData: String; bError, bTerminate: Boolean);
    // IDropTarget
    function DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult; stdcall;
    function DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    function DragLeave: HResult; stdcall;
    function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    m_ExecutionState: TExecutionState;
    m_ReqProc: TRequestProcessor;
    m_sIniFileName: String;
    m_sOldHintString: String;
    m_sHintValue: String;
    m_clpPerl: TCLProcess;
    m_sAppPath: String;
    function ShowFile(sFileName: String; nLine: Integer; bError: Boolean; bChangeProject: Boolean): TMDIChild;
    procedure ShowWatches;
    procedure StartDebugging(sParams: String; bStepInto: Boolean);
    procedure SaveDesktop(sDesktopName: String);
    function LoadDesktop(sDesktopName: String): Boolean;
    procedure SaveSettings;
    function LoadSettings: String;
    procedure SaveProjectSettings;
    procedure LoadProjectSettings;
    function GetVisibleDockClientCount(win: TWinControl): Integer;
    procedure RegisterVisibilityChange(win: TWinControl; pc: TPageControl);
    procedure HandleShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
    procedure HandleHint(Sender: TObject);
    procedure HandleActiveProjectClick(Sender: TObject);
    procedure ChangeProject(sNewProjectFileName: String);
    procedure UpdateProjectMenu;
    procedure SendToStdIn(s: String);
    procedure ShowError(sFileName: String; nLine: Integer);
    procedure DispatchBPChangeEvent(Sender: TObject; sFileName: String; nLine: Integer; sCondition: String; bDelete: Boolean);
    procedure SendBreakpointsToDebugger(bpl: TBreakpointList);
    function BlockingEval(sCode: String): String;
    property ActiveProjectFile: String Read m_sActiveProjectFile;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  f_About, f_Variables, f_ConsoleAndCommunication, f_Modules,
  f_Breakpoints, f_CallStack, f_ErrorOutput, f_Preferences, f_GoTo;


procedure TMainForm.WndProc(var Message: TMessage);
begin
  inherited WndProc(Message);
end;


procedure TMainForm.SendBreakpointsToDebugger(bpl: TBreakpointList);
var
  i: Integer;
begin
  for i := 0 to bpl.Count - 1 do begin
    MainForm.m_ReqProc.Request(DM_CHANGE_BP_REQ,
        bpl.Name + #13#10
      + IntToStr(bpl[i].Line) + #13#10
      + bpl[i].Condition + #13#10
      + 'TRUE', 1);
  end;
end;


procedure TMainForm.DispatchBPChangeEvent(Sender: TObject; sFileName: String; nLine: Integer; sCondition: String; bDelete: Boolean);
var
  mdi: TMDIChild;
begin
  if Sender is TMDIChild then begin
    // Dispatch to breakpoint table
    if bDelete
      then frmBreakpoints.DeleteBreakpoint(Sender, sFileName, nLine, sCondition)
      else frmBreakpoints.AddBreakpoint(Sender, sFileName, nLine, sCondition);
  end else begin
    // Dispatch to MDI child
    mdi := ChildFromName(sFileName);
    if mdi <> nil then begin
      if bDelete
        then mdi.DeleteBreakpoint(Sender, sFileName, nLine, sCondition)
        else mdi.AddBreakpoint(Sender, sFileName, nLine, sCondition);
    end;
  end;
  if bDelete
    then MainForm.m_ReqProc.Request(DM_CHANGE_BP_REQ, sFileName + #13#10 + IntToStr(nLine) + #13#10#13#10'FALSE', 1)
    else MainForm.m_ReqProc.Request(DM_CHANGE_BP_REQ, sFileName + #13#10 + IntToStr(nLine) + #13#10 + sCondition + #13#10'TRUE', 1);
end;


function TMainForm.DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult;
begin
  dwEffect := DROPEFFECT_COPY;
  Result := S_OK;
end;


function TMainForm.DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult;
begin
  dwEffect := DROPEFFECT_COPY;
  Result := S_OK;
end;


function TMainForm.DragLeave: HResult;
begin
  Result := S_OK;
end;


function TMainForm.Drop(const dataObj: IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HResult;
var
  formatEtc: TFormatEtc;
  stgMedium: TStgMedium;
  i, nCount: Integer;
  buf: array[0..MAX_PATH] of char;
begin
  if dataObj = nil then begin
    Result := S_OK;
    exit;
  end;
  with formatEtc do begin
    cfFormat := CF_HDROP;
    ptd := nil;
    dwAspect := DVASPECT_CONTENT;
    lindex := -1;
    tymed := TYMED_HGLOBAL; 
  end;
  OleCheck(dataObj.GetData(formatEtc, stgMedium));
  try
    nCount := DragQueryFile(stgMedium.hGlobal, $FFFFFFFF, @buf, SizeOf(buf));
    for i := 0 to nCount - 1 do begin
      DragQueryFile(stgMedium.hGlobal, i, @buf, SizeOf(buf));
      ShowFile(buf, -1, False, True);
    end;
  finally
    ReleaseStgMedium(stgMedium);
  end;
  Result := S_OK;
end;


procedure TMainForm.ShowError(sFileName: String; nLine: Integer);
begin
  ShowFile(sFileName, nLine, True, False);
end;


procedure TMainForm.SendToStdIn(s: String);
begin
  case m_ExecutionState of
    ecsRun: begin
      m_clpPerl.Input(s);
    end;
  else
    m_ReqProc.Dispatcher.SendToStdIn(s);
  end;
end;


function TMainForm.GetBreakpointCount: Integer;
begin
  Result := frmBreakpoints.Count;
end;


procedure TMainForm.HandleCLEvent(Sender: TObject; sData: String; bError, bTerminate: Boolean);
begin
  if bError then begin
    ReceiveFromStdErr(sData);
  end else begin
    ReceiveFromStdOut(sData);
  end;
  if bTerminate then begin
    HandleTerminate;
  end;
end;


procedure TMainForm.UpdateProjectMenu;
var
  i: Integer;
  mi: TMenuItem;
  sl: TStringList;
begin
  if m_sActiveProjectFile = ''
    then Caption := 'Open Perl IDE <' + 'no active project' + '> '
    else Caption := 'Open Perl IDE <' + ExtractFileName(m_sActiveProjectFile) + '> ';
  miSetActiveProject.Clear;
  sl := TStringList.Create;
  for i := 0 to MDIChildCount - 1 do
    sl.AddObject(TMDIChild(MDIChildren[i]).FileName, MDIChildren[i]);
  sl.Sort;
  for i := 0 to sl.Count - 1 do begin
    if UpperCase(ExtractFileExt(TMDIChild(sl.Objects[i]).FileName)) = '.PL' then begin
      mi := TMenuItem.Create(Self);
      mi.Caption := StringReplace(TMDIChild(sl.Objects[i]).FileName, '&', '&&', [rfReplaceAll]);
      mi.Checked := UpperCase(m_sActiveProjectFile) = UpperCase(mi.Caption);
      mi.OnClick := HandleActiveProjectClick;
      miSetActiveProject.Add(mi);
    end;
  end;
  sl.Free;
end;


procedure TMainForm.ChangeProject(sNewProjectFileName: String);
begin
  SaveProjectSettings;
  m_sActiveProjectFile := sNewProjectFileName;
  LoadProjectSettings;
  UpdateProjectMenu;
  UpdateRunActions;
end;

procedure TMainForm.HandleActiveProjectClick(Sender: TObject);
var
  sNewProject: String;
begin
  sNewProject := TMenuItem(Sender).Caption;
  sNewProject := StringReplace(sNewProject, '&&', #13, [rfReplaceAll]);
  sNewProject := StringReplace(sNewProject, '&', '', [rfReplaceAll]);
  sNewProject := StringReplace(sNewProject, '#13', '&', [rfReplaceAll]);
  ShowFile(sNewProject, -1, False, True);
end;


procedure TMainForm.HandleHint(Sender: TObject);
begin

end;


function TMainForm.BlockingEval(sCode: String): String;
var
  OldExecState: TExecutionState;
  rcv: IMessageReceiver;
begin
  Result := '<internal sync error>';
  OldExecState := m_ExecutionState;

  m_ReqProc.PauseProcessing;
  while WaitForSingleObject(m_ReqProc.ProcessingPaused.Handle, 100) <> WAIT_OBJECT_0 do begin
    Application.ProcessMessages;
  end;

  m_ExecutionState := ecsPendingCommand;

  // Switching message receiver to self is safe, because in Debug- and Compile-
  // mode all requests are handled from RequestProcessor and dispatched to
  // *blocking* PerlDebugger. So if the RequestProcessor is paused, no single
  // line of perl code is executed and consequently no MsgReports or
  // Output/Error-Events are generated.
  // If we are in Run-Mode, the RequestProcessor is not used, so switching is
  // safe, too.
  rcv := m_ReqProc.Dispatcher.OnReceiveMessage;
  try
    m_ReqProc.Dispatcher.OnReceiveMessage := Self;
    m_ReqProc.Dispatcher.SendMessage(DM_EVAL_CODE_REQ, sCode);
    Result := m_sHintValue;
  finally
    m_ReqProc.Dispatcher.OnReceiveMessage := rcv;
    m_ExecutionState := OldExecState;
    m_ReqProc.ContinueProcessing;
  end;
end;


procedure TMainForm.HandleShowHint(var HintStr: string; var CanShow: Boolean;
  var HintInfo: THintInfo);
begin
  HintInfo.ReshowTimeout := 1;
  if HintStr = '' then begin
    m_sOldHintString := '';
    Application.HideHint;
    exit;
  end;
  CanShow := (HintStr <> m_sOldHintString) and (m_ExecutionState = ecsDebug)
    and (copy(HintStr, 1, 1)[1] in ['\', '''', '"', '$', '@', '%', '0'..'9']);
  m_sOldHintString := HintStr;

  if CanShow then HintStr := HintStr + ': '
    + BlockingEval('0'#13#10'ShowDerefValues(\' + HintStr + ')');
end;


procedure TMainForm.RegisterVisibilityChange(win: TWinControl; pc: TPageControl);
var
  bAllow: Boolean;
  b: Boolean;
begin
  b := win.Visible;
  win.Visible := True;
  if b then begin
    if Assigned(pc.OnDockDrop) then pc.OnDockDrop(pc, nil, 0, 0);
  end else begin
    if Assigned(pc.OnUnDock) then pc.OnUnDock(pc, win, nil, bAllow);
  end;
  win.Visible := b;
end;



function TMainForm.GetVisibleDockClientCount(win: TWinControl): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to win.DockClientCount - 1 do begin
    if win.DockClients[i].Visible then inc(Result);
  end;
end;


procedure TMainForm.SaveProjectSettings;
var
  ini: TIniFile;
  i: Integer;
  sl: TStringList;
  s: String;
begin
  if m_sActiveProjectFile = '' then exit;
  ini := TIniFile.Create(ChangeFileExt(m_sActiveProjectFile, '.vpd'));
  sl := TStringList.Create;
  sl.CommaText := frmBreakpoints.AsString;
  ini.EraseSection('Breakpoints');
  for i := 0 to sl.Count - 1 do begin
    ini.WriteString('Breakpoints', IntToStr(i), sl[i]);
  end;
  ini.EraseSection('Watches');
  s := frmVariables.AsString;
  i := 0;
  while s <> '' do begin
    ini.WriteString('Watches', IntToStr(i), copy(s, 1, 1000));
    s := copy(s, 1001, MAXINT);
    inc(i);
  end;
  ini.Free;
  sl.Free;
end;


procedure TMainForm.LoadProjectSettings;
var
  i: Integer;
  slSection, slValues: TStringList;
  ini: TIniFile;
  s: String;
begin
  if m_sActiveProjectFile = '' then exit;
  slSection := TStringList.Create;
  slValues := TStringList.Create;
  ini := TIniFile.Create(ChangeFileExt(m_sActiveProjectFile, '.vpd'));
  ini.ReadSection('Breakpoints', slSection);
  for i := 0 to slSection.Count - 1 do begin
    s := ini.ReadString('Breakpoints', slSection[i], '');
    slValues.Add(s);
  end;
  frmBreakpoints.AsString := slValues.CommaText;
  ini.ReadSection('Watches', slSection);
  s := '';
  for i := 0 to slSection.Count - 1 do begin
    s := s + ini.ReadString('Watches', slSection[i], '');
  end;
  frmVariables.AsString := s;

  slValues.Free;
  slSection.Free;
end;



procedure TMainForm.SaveSettings;
var
  ini: TIniFile;
  sl: TStringList;
  i: Integer;
  mdi: TMDIChild;
begin
  sl := TStringList.Create;
  ini := TIniFile.Create(m_sIniFileName);

  ini.WriteString('Environment', 'LastProject', m_sActiveProjectFile);

  ini.EraseSection('Editor windows');

  i := MDIChildCount;
  while i > 0 do begin
    mdi := TMDIChild(ActiveMDIChild);
    ini.WriteString('Editor windows', mdi.FileName, WinControlToString(mdi));
    Previous;
    dec(i);
  end;

  ini.Free;
  sl.Free;
end;


function TMainForm.LoadSettings: String;
var
  ini: TIniFile;
  sl: TStringList;
  sDesktop: String;
  i: Integer;
  sFileName: String;
  mdi: TMDIChild;
  bVisible: Boolean;
  s: String;
begin
  Result := '';
  sl := TStringList.Create;
  ini := TIniFile.Create(m_sIniFileName);
  // Set current desktop
  sDesktop := ini.ReadString('Environment', 'DefaultDesktop', '');
  if not LoadDesktop(sDesktop) then begin
    sDesktop := 'Default';
    if not LoadDesktop(sDesktop) then begin
      ini.Free;
      InitDockingWindows;
      SaveDesktop(sDesktop);
      ini := TIniFile.Create(m_sIniFileName);
      ini.WriteString('Environment', 'DefaultDesktop', sDesktop);
    end;
  end;
  cbxDesktop.Text := sDesktop;
  frmPreferences.cbxDefaultDesktop.Text := sDesktop;
  frmPreferences.cbxRunDesktop.Text := ini.ReadString('Environment', 'RunDesktop', sDesktop);
  frmPreferences.cbxDebugDesktop.Text := ini.ReadString('Debug', 'Desktop', sDesktop);

  // Load all desktops names
  ini.ReadSection('Desktops', sl);
  cbxDesktop.Items.Assign(sl);
  frmPreferences.cbxDefaultDesktop.Items.Assign(sl);
  frmPreferences.cbxRunDesktop.Items.Assign(sl);
  frmPreferences.cbxDebugDesktop.Items.Assign(sl);

  // Debug options
  frmPreferences.chbEvaluateHint.Checked := ini.ReadString('Debug', 'EvaluateHint', 'FALSE') <> 'FALSE';

  // Editor windows
  sl.Clear;
  ini.ReadSection('Editor windows', sl);
  for i := sl.Count - 1 downto 0 do begin
    sFileName := sl[i];
    if FileExists(sFileName) then begin
      mdi := ShowFile(sFileName, -1, False, False);
      StringToWinControl(mdi, ini.ReadString('Editor windows', sFileName, ''), bVisible);
    end;
  end;

  WindowState := m_ws;
  m_bInitializing := False;


  // Environment options
  s := ini.ReadString('Environment', 'LastProject', '');
  if FileExists(s) then Result := s;

  ini.Free;
  sl.Free;
end;


function TMainForm.WinControlToString(win: TWinControl): String;
var
  sl: TStringList;
  sVisible: String;
begin
  if win.Visible then sVisible := 'TRUE' else sVisible := 'FALSE';
  sl := TStringList.Create;
  sl.Add('Left=' + IntToStr(win.Left));
  sl.Add('Top=' + IntToStr(win.Top));
  sl.Add('Width=' + IntToStr(win.Width));
  sl.Add('Height=' + IntToStr(win.Height));
  sl.Add('Visible=' + sVisible);
  if win is TForm
    then sl.Add('WindowState=' + IntToStr(ord(TForm(win).WindowState)));
  Result := sl.CommaText;
  sl.Free;
end;


procedure TMainForm.StringToWinControl(win: TWinControl; s: String; var bVisible: Boolean);
var
  sl: TStringList;
  i: Integer;
  sName: String;
  nLeft, nTop, nWidth, nHeight: Integer;
begin
  nLeft := 10;
  nTop := 10;
  nWidth := 10;
  nHeight := 10;
  sl := TStringList.Create;
  sl.CommaText := s;
  for i := 0 to sl.Count - 1 do begin
    sName := UpperCase(sl.Names[i]);
    if sName = 'LEFT'
      then nLeft := StrToIntDef(sl.Values[sl.Names[i]], 100);
    if sName = 'TOP'
      then nTop := StrToIntDef(sl.Values[sl.Names[i]], 100); ;
    if sName = 'WIDTH'
      then nWidth := StrToIntDef(sl.Values[sl.Names[i]], 100);
    if sName = 'HEIGHT'
      then nHeight := StrToIntDef(sl.Values[sl.Names[i]], 100);
    if sName = 'VISIBLE'
      then bVisible := UpperCase(sl.Values[sl.Names[i]]) <> 'FALSE';
    if (sName = 'WINDOWSTATE') and (win is TForm) then begin
      if win = Self then m_ws := TWindowState(StrToIntDef(sl.Values[sl.Names[i]], 0));
    end;

  end;
  sl.Free;

  if (not (win is TForm)) or (TForm(win).WindowState = wsNormal)
    then win.SetBounds(nLeft, nTop, nWidth, nHeight);
end;


function TMainForm.PageControlToString(pc: TPageControl): String;
var
  i: Integer;
  sl: TStringList;
  win: TWinControl;
begin
  sl := TStringList.Create;
  if pc.ActivePage <> nil
    then sl.Add('TabIndex=' + IntToStr(pc.ActivePage.TabIndex))
    else sl.Add('TabIndex=-1');
  sl.Add('Width=' + IntToStr(pc.Width));
  sl.Add('Height=' + IntToStr(pc.Height));
  for i := 0 to pc.DockClientCount - 1 do begin
    win := TWinControl(pc.DockClients[i]);
    sl.Add(win.Name + '=' + WinControlToString(win));
  end;
  Result := sl.CommaText;
  sl.Free;
end;


procedure TMainForm.StringToPageControl(pc: TPageControl; s: String);
var
  sl: TStringList;
  i: Integer;
  cmp: TComponent;
  bVisible: Boolean;
  nTabIndex: Integer;
  sName: String;
  nWidth, nHeight: Integer;
begin
  pc.Visible := False;
  nTabIndex := -1;
  nWidth := 100;
  nHeight := 100;
  sl := TStringList.Create;
  sl.CommaText := s;
  for i := 0 to sl.Count - 1 do begin
    sName := UpperCase(sl.Names[i]);
    if sName = 'TABINDEX' then begin
      nTabIndex := StrToIntDef(sl.Values[sl.Names[i]], -1);
    end;
    if sName = 'WIDTH' then nWidth := StrToIntDef(sl.Values[sl.Names[i]], 100);
    if sName = 'HEIGHT' then nHeight := StrToIntDef(sl.Values[sl.Names[i]], 100);
    // Dockable windows are owned by Application
    cmp := Application.FindComponent(sl.Names[i]);
    if (cmp <> nil) and (cmp is TWinControl) then begin
      TWinControl(cmp).ManualDock(pc);
      StringToWinControl(TWinControl(cmp), sl.Values[sl.Names[i]], bVisible);
      TWinControl(cmp).Visible := bVisible;
    end;
  end;
  pc.SetBounds(pc.Left, pc.Top, nWidth, nHeight);
  if nTabIndex > -1 then pc.ActivePage := pc.Pages[nTabIndex];
  pc.SelectNextPage(True);
  pc.SelectNextPage(False);
  sl.Free;
  pc.Visible := True;
end;


procedure TMainForm.SaveDesktop(sDesktopName: String);
var
  ini: TIniFile;
  i: Integer;
  sl, slWindows: TStringList;
  win: TWinControl;
begin
  slWindows := TStringList.Create;
  sl := TStringList.Create;
  ini := TIniFile.Create(m_sIniFileName);
  for i := 0 to Application.ComponentCount - 1 do begin
    if Application.Components[i].Name <> '' then begin
      win := TWinControl(Application.Components[i]);
      if (win.Parent = nil) and (not (win is TMDIChild)) then begin
        sl.Add(win.Name + '=' + WinControlToString(win));
      end;
    end;
  end;

  slWindows.Add('Floating=' + sl.CommaText);
  sl.Clear;

  slWindows.Add('pcLeft=' + PageControlToString(pcLeft));
  slWindows.Add('pcTop=' + PageControlToString(pcTop));
  slWindows.Add('pcRight=' + PageControlToString(pcRight));
  slWindows.Add('pcBottom=' + PageControlToString(pcBottom));

  ini.WriteString('Desktops', sDesktopName, slWindows.CommaText);

  ini.Free;
  sl.Free;
  slWindows.Free;
end;


function TMainForm.LoadDesktop(sDesktopName: String): Boolean;
var
  ini: TIniFile;
  i, j: Integer;
  cmp: TComponent;
  sl, slWindows: TStringList;
  s: String;
  bVisible: Boolean;
  ptLeftTop, ptBottomRight: TPoint;
begin
  cbxDesktop.SetFocus;

  ini := TIniFile.Create(m_sIniFileName);
  s := ini.ReadString('Desktops', sDesktopName, '');
  Result := s <> '';
  if Result then begin
    while pcLeft.DockClientCount > 0 do begin
      with pcLeft.DockClients[0] do begin
        ptLeftTop := ClientToScreen(Point(Left, Top));
        ptBottomRight := ClientToScreen(Point(Left + Width, Top + Height));
        ManualFloat(Rect(ptLeftTop.x, ptLeftTop.y, ptBottomRight.x, ptBottomRight.y));
      end;
    end;
    while pcTop.DockClientCount > 0 do begin
      with pcTop.DockClients[0] do begin
        ptLeftTop := ClientToScreen(Point(Left, Top));
        ptBottomRight := ClientToScreen(Point(Left + Width, Top + Height));
        ManualFloat(Rect(ptLeftTop.x, ptLeftTop.y, ptBottomRight.x, ptBottomRight.y));
      end;
    end;
    while pcRight.DockClientCount > 0 do begin
      with pcRight.DockClients[0] do begin
        ptLeftTop := ClientToScreen(Point(Left, Top));
        ptBottomRight := ClientToScreen(Point(Left + Width, Top + Height));
        ManualFloat(Rect(ptLeftTop.x, ptLeftTop.y, ptBottomRight.x, ptBottomRight.y));
      end;
    end;
    while pcBottom.DockClientCount > 0 do begin
      with pcBottom.DockClients[0] do begin
        ptLeftTop := ClientToScreen(Point(Left, Top));
        ptBottomRight := ClientToScreen(Point(Left + Width, Top + Height));
        ManualFloat(Rect(ptLeftTop.x, ptLeftTop.y, ptBottomRight.x, ptBottomRight.y));
      end;
    end;

    sl := TStringList.Create;
    slWindows := TStringList.Create;
    slWindows.CommaText := '"' + s + '"';
    for i := 0 to slWindows.Count - 1 do begin
      // Page controls are owned by MainForm
      cmp := FindComponent(slWindows.Names[i]);
      if (cmp <> nil) and (cmp is TPageControl) then begin
        StringToPageControl(TPageControl(cmp), slWindows.Values[slWindows.Names[i]]);
        if cmp = pcBottom then begin
          splitBottom.Align := alNone;
          splitBottom.Top := 0;
          splitBottom.Align := alBottom;
          splitBottom.Visible := True;
        end;
      end;
      if UpperCase(slWindows.Names[i]) = 'FLOATING' then begin
        sl.CommaText := slWindows.Values[slWindows.Names[i]];
        for j := 0 to sl.Count - 1 do begin
          // Dockable windows are owned by Application
          cmp := Application.FindComponent(sl.Names[j]);
          if (cmp <> nil) and (cmp is TWinControl) then begin
            StringToWinControl(TWinControl(cmp), sl.Values[sl.Names[j]], bVisible);
            TWinControl(cmp).Visible := bVisible;
          end;
        end;
      end;
    end;
    slWindows.Free;
    sl.Free;
    cbxDesktop.Text := sDesktopName;


    if not m_bInitializing then WindowState := m_ws;

  end;
  ini.Free;
end;


procedure TMainForm.StartDebugging(sParams: String; bStepInto: Boolean);
begin
  if m_ExecutionState = ecsPendingCommand then exit;
  if m_ExecutionState = ecsNone then begin
    m_ExecutionState := ecsPendingCommand;
    SaveProjectSettings;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Clear;
    frmConsoleAndCommunication.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Font.Color := clAqua;
    if bStepInto
      then m_ReqProc.Request(DM_START_REQ, m_sActiveProjectFile
        + #13#10 + frmConsoleAndCommunication.edtParams.Text
        + #13#10'TRUE'#13#10'FALSE', 0)
      else m_ReqProc.Request(DM_START_REQ, m_sActiveProjectFile
        + #13#10 + frmConsoleAndCommunication.edtParams.Text
        + #13#10'FALSE'#13#10'FALSE', 0);
    if (frmPreferences.cbxDebugDesktop.Text <> cbxDesktop.Text)
      then LoadDesktop(frmPreferences.cbxDebugDesktop.Text);
  end;
end;


procedure TMainForm.UpdateRunActions;
var
  i: Integer;
begin
  // Change action state if not running or debugging
  if m_ExecutionState <> ecsNone then exit;
  for i := 0 to ActionList.ActionCount - 1 do begin
    with TAction(ActionList.Actions[i]) do begin
      if (Category = 'Run') or (Category = 'Project') then Enabled := m_sActiveProjectFile <> '';
    end;
  end;
end;


function TMainForm.ReceiveFromStdErr(sData: String): Integer;
begin
  Result := -1;
  if csDestroying in ComponentState then exit;
  frmError.memoErrorOutput.Lines.Text
    := frmError.memoErrorOutput.Lines.Text + sData;
  while frmError.memoErrorOutput.Lines.Count > 100 do begin
    frmError.memoErrorOutput.Lines.Delete(0);
  end;
  with frmError.memoErrorOutput.Lines do begin
    Strings[Count - 1] := Strings[Count - 1];
  end;
  Result := 0;
end;


function TMainForm.HandleTerminate: Integer;
var
  i: Integer;
  mdi: TMDIChild;
  sFileName: String;
  nLine: Integer;
begin
  Result := 0;
  if csDestroying in ComponentState then exit; 
  if m_ExecutionState <> ecsNone then begin
    if m_ExecutionState = ecsDebug then begin
      m_ExecutionState := ecsPendingCommand;
      m_ReqProc.Request(DM_STOP_REQ, '', 0);
    end;
    m_ExecutionState := ecsNone;
    SaveProjectSettings;
    frmConsoleAndCommunication.memoConsole.Font.Color := clSilver;
    for i := 0 to MDIChildCount - 1 do begin
      mdi := TMDIChild(MDIChildren[i]);
      mdi.SynEdit.ReadOnly := False;
      mdi.SynEdit.Color := clWindow;
      mdi.SetCurrentLine(-1);
    end;
    frmError.memoErrorOutput.Lines.Add('');
    with frmError.memoErrorOutput.Lines do begin
      i := 0;
      while (i < Count) do begin
        if frmError.ParseErrorLine(Strings[i], sFileName, nLine) then begin
          ShowError(sFileName, nLine);
          break;
        end;
        inc(i);
      end;
    end;
    if (frmPreferences.cbxDefaultDesktop.Text <> cbxDesktop.Text) then begin
      LoadDesktop(frmPreferences.cbxDefaultDesktop.Text);
    end;

  end;
end;


function TMainForm.ReceiveFromStdOut(sData: String): Integer;
begin
  if csDestroying in ComponentState then begin
    Result := -1;
    exit;
  end;
  frmConsoleAndCommunication.memoConsole.Lines.Text
    := frmConsoleAndCommunication.memoConsole.Lines.Text + sData;
  while frmConsoleAndCommunication.memoConsole.Lines.Count > 100 do begin
    frmConsoleAndCommunication.memoConsole.Lines.Delete(0);
  end;
  with frmConsoleAndCommunication.memoConsole.Lines do begin
    Strings[Count - 1] := Strings[Count - 1];
  end;
  Result := 0;
end;


procedure TMainForm.ShowWatches;
var
  i: Integer;
begin
  // Important: Last item is placeholder for a new watch
  for i := 0 to frmVariables.eltWatches.Items.VisCount - 2 do begin
    m_ReqProc.Request(DM_EVAL_CODE_REQ,
      IntToStr(Longint(frmVariables.eltWatches.Items.ItemAsVis[i]))
        + #13#10 + 'ShortEval(\' + frmVariables.eltWatches.Items.ItemAsVis[i].GetFullNameEx('->', False) + ')',
      100 + i * 10);
  end;
end;


function TMainForm.ChildFromName(sName: String): TMDIChild;
var
  i: Integer;
  sTransformedName, sTransformedResultName: String;
begin
  i := 0;
  Result := nil;
  while i < MDIChildCount do begin
    Result := TMDIChild(MDIChildren[i]);
    sTransformedName := StringReplace(sName, '/', '\', [rfReplaceAll]);
    sTransformedResultName := StringReplace(Result.FileName, '/', '\', [rfReplaceAll]);
    sTransformedName := ExtractRelativePath(m_sAppPath, sTransformedName);
    sTransformedResultName := ExtractRelativePath(m_sAppPath, sTransformedResultName);
    if UpperCase(sTransformedResultName) = UpperCase(sTransformedName)
      then break
      else Result := nil;
    inc(i);
  end;
end;

function TMainForm.ShowFile(sFileName: String; nLine: Integer; bError: Boolean; bChangeProject: Boolean): TMDIChild;
var
  wnd: HWnd;
begin               
  Result := ChildFromName(sFileName);
  if Result <> nil then begin
    wnd := GetWindow(Result.Handle, GW_HWNDNEXT);
    SendMessage(ClientHandle, WM_MDINEXT, wnd, 1);
  end else begin
    Result := CreateMDIChild(sFileName, bChangeProject);
  end;
  if nLine > -1 then begin
    if bError
      then Result.SetErrorLine(nLine)
      else Result.SetCurrentLine(nLine);
  end;
  if bChangeProject and (UpperCase(ExtractFileExt(Result.FileName)) = '.PL')
    then ChangeProject(Result.FileName);
end;


function TMainForm.HandleDebugMessage(nMsgID: Integer; sData: String): Integer;
var
  sl: TStringList;
  s, sName, sValue: String;
  nLevel: Integer;
  mdi: TMDIChild;
  eltItem: TElTreeItem;
  sRequestID: String;
  elt: TElTreeItem;
begin
  if (csDestroying in ComponentState) or (m_ExecutionState = ecsNone) then begin
    Result := -1;
    exit;
  end;
  sl := TStringList.Create;
  Result := 0;
  case nMsgID of
    DM_CMD_RSP: begin
      sl.Text := sData;
      s := 'Dispatching ' + MsgToStr(StrToInt(sl[0])) + ': ' + ErrorToStr(StrToInt(sl[1]));
      frmConsoleAndCommunication.memoCommunicationLog.Lines.Add(DateTimeToStr(Now) + ': ' + s);
    end;
    DM_START_REP: begin
      if m_ExecutionState = ecsPendingCommand then m_ExecutionState := ecsDebug;
    end;
    DM_STOP_REP: begin
    end;
    DM_LINE_REP: begin
      if (m_ExecutionState = ecsDebug) and (not m_bIgnoreLineReport) then begin
        sl.Text := sData;
        ShowFile(sl[0], StrToInt(sl[1]), False, False);
        ShowWatches;
        m_ReqProc.Request(DM_CALLSTACK_REQ, '1', 101);
      end;
      m_bIgnoreLineReport := False;
    end;
    DM_EVAL_CODE_REP: begin
      sl.Text := sData;
      if sl.Count > 0 then begin
        sRequestID := sl[0];
        sl.Delete(0);
      end else begin
        sRequestID := '';
      end;
      if sl.Count > 0 then begin
        sName := sl[0];
        sl.Delete(0);
        sValue := sl.Text;
      end else begin
        sName := '';
        sValue := '';
      end;

      if sValue = '' then sValue := '<undef>';
      if copy(sValue, Length(sValue) - 1, 2) = #13#10
        then sValue := copy(sValue, 1, Length(sValue) - 2);

      if m_ExecutionState = ecsPendingCommand then begin
        m_sHintValue := sValue;
      end else begin
        frmVariables.UpdateVariable(sRequestID, sName, sValue);
      end;
    end;
    DM_MODULE_LOADED_REP: begin
      eltItem := frmModules.eltModules.Items.AddItem(nil);
      eltItem.Text := sData;
      // Set all breakpoints for this module
      SendBreakpointsToDebugger(frmBreakpoints.Breakpoints[sData]);
      mdi := ChildFromName(sData);
      if mdi <> nil then begin
        mdi.SynEdit.Color := clBtnFace;
        mdi.SynEdit.ReadOnly := True;
      end;
    end;
    DM_CALLSTACK_REP: begin
      sl.Text := sData;
      nLevel := StrToInt(sl[0]);
      if nLevel = 1 then frmCallStack.eltCallstack.Items.Clear;
      if (sl.Count > 1) and (m_ExecutionState = ecsDebug) then begin
        elt := frmCallStack.eltCallStack.Items.AddItem(nil);
        elt.Text := sl[0];
        elt.SubItems.Add(sl[1]);
//        frmCallStack.memoCallStack.Lines.Add('Level ' + sl[0] + ': ' + sl[1]);
        m_ReqProc.Request(DM_CALLSTACK_REQ, IntToStr(nLevel + 1),
          100 + nLevel + 1);
      end;
    end;
  else
  end;
  sl.Free;

  if nMsgID <> DM_CMD_RSP then begin
    s := 'Receiving ' + MsgToStr(nMsgID) + ': ' + sData;
    s := StringReplace(s, #13#10, ', ', [rfReplaceAll]);
    while frmConsoleAndCommunication.memoCommunicationLog.Lines.Count > 100 do begin
      frmConsoleAndCommunication.memoCommunicationLog.Lines.Delete(0);
    end;
    frmConsoleAndCommunication.memoCommunicationLog.Lines.Add(DateTimeToStr(Now) + ': ' + s);
  end;

end;


procedure TMainForm.InitDockingWindows;
begin
  frmVariables.ManualDock(pcLeft);
  frmBreakpoints.ManualDock(pcLeft);
  frmModules.ManualDock(pcLeft);
  frmConsoleAndCommunication.ManualDock(pcBottom);
  frmError.ManualDock(pcBottom);
  frmCallStack.ManualDock(pcBottom);
  frmVariables.Show;
  frmBreakpoints.Show;
  frmModules.Show;
  frmConsoleAndCommunication.Show;
  frmError.Show;
  frmCallStack.Show;
end;


function TMainForm.CreateMDIChild(const Name: string; bChangeProject: Boolean): TMDIChild;
begin
  { create a new MDI child window }
  Result := TMDIChild.Create(Application);

  if (Name = '') or (FileExists(Name)) then begin
    Result.OpenFile(Name);
    if UpperCase(ExtractFileExt(Name)) = '.PL' then begin
      if bChangeProject
        then ChangeProject(Name)
        else UpdateProjectMenu;
    end;

    Result.Breakpoints := frmBreakpoints.Breakpoints[Name].AsString;

    if m_ExecutionState = ecsDebug then begin
      Result.SynEdit.Color := clBtnFace;
      Result.SynEdit.ReadOnly := True;
      SendBreakpointsToDebugger(frmBreakpoints.Breakpoints[Name]);
    end;
  end;
  tcFiles.Tabs.Insert(0, ExtractRelativePath(m_sAppPath, Result.FileName));
  tcFiles.TabIndex := 0;

end;

procedure TMainForm.acFileNewExecute(Sender: TObject);
begin
  ShowFile('', -1, False, False);
end;

procedure TMainForm.acFileOpenExecute(Sender: TObject);
var
  i: Integer;
begin
  if OpenDialog.Execute then begin
    for i := 0 to OpenDialog.Files.Count - 1 do
      ShowFile(OpenDialog.Files[i], -1, False, True);
  end;
end;

procedure TMainForm.acFileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.pcLeftDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  if pcLeft.Width = 0 then begin
    pcLeft.Width := 200;
    splitLeft.Align := alLeft;
    splitLeft.Visible := True;
  end;
end;

procedure TMainForm.pcLeftUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
begin
  if GetVisibleDockClientCount(Sender as TWinControl) < 2 then begin
    splitLeft.Visible := False;
    splitLeft.Align := alNone;
    pcLeft.Width := 0;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  sDebugScriptTemplate: String;
begin
  m_bInitializing := True;
  OleInitialize(nil);
  OleCheck(RegisterDragDrop(Handle, Self));
  m_sAppPath := ExtractFilePath(Application.ExeName);
  Application.HintPause := 0;
  Application.OnShowHint := HandleShowHint;
  Application.OnHint := HandleHint;
  m_sIniFileName := ExtractFilePath(Application.ExeName) + 'PerlIDE.ini';
  sDebugScriptTemplate := ExtractFilePath(Application.ExeName) + 'dbTemplate.txt';
  if not FileExists(sDebugScriptTemplate)
    then memoDebugScriptTemplate.Lines.SaveToFile(sDebugScriptTemplate);
  m_ExecutionState := ecsNone;
  m_ReqProc := TRequestProcessor.Create(TPerlDebugger.Create(Self) as IMessageDispatcher);
  pcLeft.Width := 0;
  pcRight.Width := 0;
  pcTop.Height := 0;
  pcBottom.Height := 0;
  cbxDesktop.ItemIndex := 0;
end;

procedure TMainForm.pcBottomDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  if pcBottom.Height = 0 then begin
    pcBottom.Align := alNone;
    pcBottom.Top := 0;
    pcBottom.Height := 200;
    pcBottom.Align := alBottom;
    if pcBottom.Visible then begin
      splitBottom.Align := alNone;
      splitBottom.Top := 0;
      splitBottom.Align := alBottom;
      splitBottom.Visible := True;
    end;
  end;
end;

procedure TMainForm.pcBottomUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
begin
  if GetVisibleDockClientCount(Sender as TWinControl) < 2 then begin
    splitBottom.Visible := False;
    splitBottom.Align := alNone;
    pcBottom.Height := 0;
  end;
end;

procedure TMainForm.pcTopDockDrop(Sender: TObject; Source: TDragDockObject;
  X, Y: Integer);
begin
  if pcTop.Height = 0 then begin
    pcTop.Align := alNone;
    pcTop.Top := 10;
    pcTop.Height := 200;
    pcTop.Align := alTop;
    if pcTop.Visible then begin
      splitTop.Align := alNone;
      splitTop.Top := 210;
      splitTop.Align := alTop;
      splitTop.Visible := True;
      pnlTabs.Top := 300;
    end;
  end;
(*
  if pcTop.Height = 0 then begin
    pcTop.Height := 200;
    splitTop.Align := alTop;
    splitTop.Visible := True;
  end;
*)
end;

procedure TMainForm.pcTopUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
begin
  if GetVisibleDockClientCount(Sender as TWinControl) < 2 then begin
    splitTop.Visible := False;
    splitTop.Align := alNone;
    pcTop.Height := 0;
  end;
end;

procedure TMainForm.pcRightDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  if pcRight.Width = 0 then begin
    pcRight.Width := 200;
    splitRight.Align := alRight;
    splitRight.Visible := True;
  end;
end;

procedure TMainForm.pcRightUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
begin
  if GetVisibleDockClientCount(Sender as TWinControl) < 2 then begin
    splitRight.Visible := False;
    splitRight.Align := alNone;
    pcRight.Width := 0;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  s: String;
begin
  frmGoto.OnGoto := HandleGoto;
  s := LoadSettings;
  if FileExists(s) then ChangeProject(s);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  m_ReqProc.Free;
  RevokeDragDrop(Handle);
  OleUninitialize;
end;

procedure TMainForm.acStepOverExecute(Sender: TObject);
begin
  if m_ExecutionState = ecsDebug
    then m_ReqProc.Request(DM_STEP_OVER_REQ, '', 10)
    else StartDebugging(frmConsoleAndCommunication.edtParams.Text, False);
end;

procedure TMainForm.acTraceIntoExecute(Sender: TObject);
begin
  if m_ExecutionState = ecsDebug
    then m_ReqProc.Request(DM_STEP_INTO_REQ, '', 5)
    else StartDebugging(frmConsoleAndCommunication.edtParams.Text, False);
end;

procedure TMainForm.acRunExecute(Sender: TObject);
begin
  if (GetBreakpointCount = 0) and (m_ExecutionState = ecsNone) then begin
    m_ExecutionState := ecsRun;
//    frmCallStack.memoCallStack.Clear;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Clear;
    frmConsoleAndCommunication.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Font.Color := clAqua;
    if (frmPreferences.cbxRunDesktop.Text <> cbxDesktop.Text)
      then LoadDesktop(frmPreferences.cbxRunDesktop.Text);
    if m_clpPerl <> nil then m_clpPerl.Free;
    m_clpPerl := TCLProcess.Create('perl '
      + '"' + m_sActiveProjectFile + '" ' + frmConsoleAndCommunication.edtParams.Text,
      ExtractFilePath(m_sActiveProjectFile), HandleCLEvent);
  end else begin
    if m_ExecutionState = ecsNone then begin
      m_bIgnoreLineReport := True;
      StartDebugging(frmConsoleAndCommunication.edtParams.Text, False);
    end;
    if m_ExecutionState in [ecsDebug, ecsPendingCommand]
      then m_ReqProc.Request(DM_RUN_REQ, '', 3);
  end;
end;

procedure TMainForm.acProgramResetExecute(Sender: TObject);
begin
  if m_ExecutionState = ecsDebug then begin
    m_ExecutionState := ecsPendingCommand;
    m_ReqProc.Request(DM_STOP_REQ, '', 0);
  end;
end;

procedure TMainForm.acFileSaveExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then TMDIChild(ActiveMDIChild).SaveFile;
end;


var
  reg: TRegistry;

procedure TMainForm.cbxDesktopKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    if cbxDesktop.Text <> '' then begin
      if MessageBox(Handle, PChar('Save current desktop as ' + cbxDesktop.Text),
        'Perl IDE', MB_YESNO) = IDYES then begin
        SaveDesktop(cbxDesktop.Text);
        if cbxDesktop.Items.IndexOf(cbxDesktop.Text) = -1
          then cbxDesktop.Items.Add(cbxDesktop.Text);
      end;
      cbxDesktop.SetFocus;
    end;
  end;
end;


procedure TMainForm.cbxDesktopClick(Sender: TObject);
begin
  if cbxDesktop.Text <> '' then LoadDesktop(cbxDesktop.Text);
end;

procedure TMainForm.acPreferencesExecute(Sender: TObject);
var
  ini: TIniFile;
begin
  frmPreferences.cbxDefaultDesktop.Items.Assign(cbxDesktop.Items);
  frmPreferences.cbxRunDesktop.Items.Assign(cbxDesktop.Items);
  frmPreferences.cbxDebugDesktop.Items.Assign(cbxDesktop.Items);
  if frmPreferences.ShowModal = mrOK then begin
    ini := TIniFile.Create(m_sIniFileName);
    // Environment options
    ini.WriteString('Environment', 'DefaultDesktop', frmPreferences.cbxDefaultDesktop.Text);
    ini.WriteString('Environment', 'RunDesktop', frmPreferences.cbxRunDesktop.Text);
    // Debug options
    ini.WriteString('Debug', 'Desktop', frmPreferences.cbxDebugDesktop.Text);
    if frmPreferences.chbEvaluateHint.Checked
      then ini.WriteString('Debug', 'EvaluateHint', 'TRUE')
      else ini.WriteString('Debug', 'EvaluateHint', 'FALSE');
    ini.Free;
  end;
end;

procedure TMainForm.Debugwindows1Click(Sender: TObject);
begin
  miVariables.Checked := frmVariables.Visible;
  miBreakpoints.Checked := frmBreakpoints.Visible;
  miModules.Checked := frmModules.Visible;
  miCallstack.Checked := frmCallStack.Visible;
end;

procedure TMainForm.miBreakpointsClick(Sender: TObject);
begin
  frmBreakpoints.Visible := not frmBreakpoints.Visible;
  if frmBreakpoints.Parent <> nil
    then RegisterVisibilityChange(frmBreakpoints, frmBreakpoints.Parent.Parent as TPageControl);
end;

procedure TMainForm.miCallstackClick(Sender: TObject);
begin
  frmCallStack.Visible := not frmCallStack.Visible;
  if frmCallStack.Parent <> nil
    then RegisterVisibilityChange(frmCallStack, frmCallStack.Parent.Parent as TPageControl);
end;

procedure TMainForm.miVariablesClick(Sender: TObject);
begin
  frmVariables.Visible := not frmVariables.Visible;
  if frmVariables.Parent <> nil
    then RegisterVisibilityChange(frmVariables, frmVariables.Parent.Parent as TPageControl);
end;

procedure TMainForm.miModulesClick(Sender: TObject);
begin
  frmModules.Visible := not frmModules.Visible;
  if frmModules.Parent <> nil
    then RegisterVisibilityChange(frmModules, frmModules.Parent.Parent as TPageControl);
end;

procedure TMainForm.miConsoleAndCommunicationClick(Sender: TObject);
begin
  frmConsoleAndCommunication.Visible := not frmConsoleAndCommunication.Visible;
  if frmConsoleAndCommunication.Parent <> nil
    then RegisterVisibilityChange(frmConsoleAndCommunication, frmConsoleAndCommunication.Parent.Parent as TPageControl);
end;

procedure TMainForm.miErrorOutputClick(Sender: TObject);
begin
  frmError.Visible := not frmError.Visible;
  if frmError.Parent <> nil
    then RegisterVisibilityChange(frmError, frmError.Parent.Parent as TPageControl);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    SaveSettings;
    SaveProjectSettings;
  except
  end;
end;

procedure TMainForm.acCompileExecute(Sender: TObject);
begin
  if m_ExecutionState = ecsNone then begin
    m_ExecutionState := ecsCompile;
//    frmCallStack.memoCallStack.Clear;
    frmCallStack.eltCallStack.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Clear;
    frmConsoleAndCommunication.memoCommunicationLog.Clear;
    frmError.memoErrorOutput.Clear;
    frmModules.eltModules.Items.Clear;
    frmConsoleAndCommunication.memoConsole.Font.Color := clAqua;
    m_ReqProc.Request(DM_START_REQ, m_sActiveProjectFile
        + #13#10 + frmConsoleAndCommunication.edtParams.Text
        + #13#10'FALSE'#13#10'TRUE', 0);
  end;
end;

procedure TMainForm.acFileSaveAsExecute(Sender: TObject);
var
  sNewFileName: String;
  bActiveProject: Boolean;
begin
  if ActiveMDIChild <> nil then begin
    bActiveProject := TMDIChild(ActiveMDIChild).FileName = m_sActiveProjectFile;
    sNewFileName := TMDIChild(ActiveMDIChild).SaveFileAs('');
    if bActiveProject then begin
      m_sActiveProjectFile := sNewFileName;
      UpdateProjectMenu;
    end else begin
      if UpperCase(ExtractFilePath(sNewFileName)) = '.PL'
        then ChangeProject(sNewFileName);
    end;
  end;
end;

procedure TMainForm.acFileCloseExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then ActiveMDIChild.Close;
end;



procedure TMainForm.pcLeftResize(Sender: TObject);
begin
  if splitLeft.Visible
    then pnlTabsLeft.Width := pcLeft.Width + splitLeft.Width
    else pnlTabsLeft.Width := pcLeft.Width;
end;

procedure TMainForm.tcFilesChange(Sender: TObject);
begin
  if csDestroying	in ComponentState then exit;
  SendMessage(ClientHandle, WM_MDIREFRESHMENU, 0, 0);
  if tcFiles.TabIndex > -1 then begin
    ShowFile(tcFiles.Tabs[tcFiles.TabIndex], -1, False, m_ExecutionState <> ecsDebug);
  end else begin
  end;
end;

procedure TMainForm.pcRightResize(Sender: TObject);
begin
  if splitRight.Visible
    then pnlTabsRight.Width := pcRight.Width + splitRight.Width
    else pnlTabsRight.Width := pcRight.Width;
end;



procedure TMainForm.HandleGoto(Sender: TObject; var sGoto: String);
var
  nLine: Integer;
  se: TSynEdit;
begin
  if ActiveMDIChild <> nil then begin
    se := TMDIChild(ActiveMDIChild).SynEdit;
    nLine := StrToIntDef(sGoto, -1);
    if (nLine > 0) and (nLine < se.Lines.Count) then begin
      se.CaretXY := Point(0, nLine);
      se.EnsureCursorPosVisible;
    end else begin
      Application.MessageBox(PChar('Line number must be between 1 and '
        + IntToStr(se.Lines.Count - 1) + '.'), 'Open Perl IDE', MB_OK);
      sGoto := '1';
    end;
  end;
end;


function TMainForm.GetSearchAndReplaceOptions: TSynSearchOptions;
begin
  Result := [];
  if frWholeWord in ReplaceDialog.Options then Result := Result + [ssoWholeWord];
  if frMatchCase in ReplaceDialog.Options then Result := Result + [ssoMatchCase];
  if not (frDown in ReplaceDialog.Options) then Result := Result + [ssoBackwards];
  if frReplace in ReplaceDialog.Options then Result := Result + [ssoReplace];
  if frReplaceAll in ReplaceDialog.Options then Result := Result + [ssoReplaceAll];
end;


function TMainForm.GetFindOptions: TSynSearchOptions;
begin
  Result := [];
  if frWholeWord in FindDialog.Options then Result := Result + [ssoWholeWord];
  if frMatchCase in FindDialog.Options then Result := Result + [ssoMatchCase];
  if not (frDown in FindDialog.Options) then Result := Result + [ssoBackwards];
end;


procedure TMainForm.acFindExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then FindDialog.Execute;
end;

procedure TMainForm.acSearchAgainExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(FindDialog.FindText, '', GetFindOptions);
  end;
end;

procedure TMainForm.FindDialogFind(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(FindDialog.FindText, '', GetFindOptions);
  end;
end;

procedure TMainForm.acReplaceExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then ReplaceDialog.Execute;
end;

procedure TMainForm.ReplaceDialogReplace(Sender: TObject);
begin
  if ActiveMDIChild <> nil then begin
    TMDIChild(ActiveMDIChild).SynEdit.SearchReplace(ReplaceDialog.FindText,
      ReplaceDialog.ReplaceText, GetSearchAndReplaceOptions);
  end;
end;

procedure TMainForm.acGoToLineNumberExecute(Sender: TObject);
begin
  if ActiveMDIChild <> nil then frmGoTo.Show;
end;

procedure TMainForm.acFileOpen2Execute(Sender: TObject);
begin
  acFileOpenExecute(nil);
end;

procedure TMainForm.acAboutExecute(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TMainForm.Outputwindows1Click(Sender: TObject);
begin
  miConsoleAndCommunication.Checked := frmConsoleAndCommunication.Visible;
  miErrorOutput.Checked := frmError.Visible;
end;

initialization
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  if reg.OpenKey('\SOFTWARE\PERL\', False) then begin
    reg.RenameValue('PERL5DB', '__PERL5DB');
  end;
finalization
  if reg.OpenKey('\SOFTWARE\PERL\', False) then begin
    reg.RenameValue('__PERL5DB', 'PERL5DB');
  end;
  reg.Free;
end.


