{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: f_Goto.pas, released 11 Mar 2001.

The Initial Developer of the Original Code is: Jrgen Gntherodt
(jguentherodt@users.sourceforge.net).

Portions created by Jrgen Gntherodt are Copyright (C) 2001 Jrgen Gntherodt.
All Rights Reserved.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: f_GoTo.pas,v 1.3 2001/03/17 04:34:59 jguentherodt Exp $

You may retrieve the latest version of this file at the Open Perl IDE
home page, located at http://www.lost-sunglasses.de
-------------------------------------------------------------------------------}
unit f_GoTo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TGotoEvent = procedure(Sender: TObject; var sGoto: String) of object;
  
  TfrmGoTo = class(TForm)
    Label1: TLabel;
    edtNewLineNumber: TEdit;
    btnGoTo: TButton;
    btnClose: TButton;
    procedure btnCloseClick(Sender: TObject);
    procedure btnGoToClick(Sender: TObject);
  private
    { Private declarations }
    m_OnGoto: TGotoEvent;
    procedure DoGoto(var sGoto: String);
  public
    { Public declarations }
    property OnGoto: TGotoEvent Read m_OnGoto Write m_OnGoto;
  end;

var
  frmGoTo: TfrmGoTo;

implementation

{$R *.DFM}

procedure TfrmGoTo.btnCloseClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmGoTo.DoGoto(var sGoto: String);
begin
  if Assigned(m_OnGoto) then m_OnGoto(Self, sGoto);
end;


procedure TfrmGoTo.btnGoToClick(Sender: TObject);
var
  sGoto: String;
begin
  sGoto := edtNewLineNumber.Text;
  DoGoto(sGoto);
  edtNewLineNumber.Text := sGoto;
end;

end.
